"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomJwtAuthGuard = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const core_1 = require("@nestjs/core");
const jwt_1 = require("@nestjs/jwt");
const abstract_guard_guard_1 = require("./abstract-guard.guard");
let CustomJwtAuthGuard = class CustomJwtAuthGuard extends abstract_guard_guard_1.AbstractGuard {
    constructor(reflector, jwtService, configService, scopeADM) {
        super();
        this.reflector = reflector;
        this.jwtService = jwtService;
        this.configService = configService;
        this.scopeADM = scopeADM;
    }
    canActivate(context) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const bearerToken = this.getAuthToken(context, 'Bearer').replace('Bearer ', '');
                const tokenPayload = yield this.jwtService.verifyAsync(bearerToken, {
                    secret: this.configService.get('auth.jwt.secret'),
                    ignoreExpiration: true,
                });
                const scopes = this.reflector.get('scopes', context.getHandler());
                if (!scopes || scopes.length === 0)
                    return true;
                if (tokenPayload.scopes.indexOf(this.scopeADM) !== -1)
                    return true;
                let scopesPermission = 0;
                scopes.forEach((scope) => {
                    if (tokenPayload.scopes.indexOf(scope) > -1)
                        scopesPermission++;
                });
                if (!scopesPermission)
                    throw new common_1.ForbiddenException('Missing Scope Authorization');
                return true;
            }
            catch (err) {
                throw new common_1.HttpException(`Error JWT Auth: ${err.message}`, err.status === common_1.HttpStatus.ACCEPTED
                    ? common_1.HttpStatus.UNAUTHORIZED
                    : err.status);
            }
        });
    }
};
exports.CustomJwtAuthGuard = CustomJwtAuthGuard;
exports.CustomJwtAuthGuard = CustomJwtAuthGuard = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.Reflector,
        jwt_1.JwtService,
        config_1.ConfigService, String])
], CustomJwtAuthGuard);
