"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticatorExtractorHelper = void 0;
class AuthenticatorExtractorHelper {
    static extractBasicAuth(authStr) {
        const b64auth = (authStr || '').split(' ')[1] || '';
        const [username, password] = Buffer.from(b64auth, 'base64')
            .toString()
            .split(':');
        return { username, password };
    }
    static extractBearerTokenAuth(authStr) {
        try {
            const base64Payload = authStr.split('.')[1];
            const payloadBuffer = Buffer.from(base64Payload, 'base64');
            return JSON.parse(payloadBuffer.toString());
        }
        catch (err) {
            return null;
        }
    }
}
exports.AuthenticatorExtractorHelper = AuthenticatorExtractorHelper;
